#include "nrutil.h"
#define TOL 2.0e-4

void mnbrak(float *ax, float* bx, float* cx, float* fa,float* fb,float* fc,CGFTargetFunc* tfunc);
float brent(float ax,float bx,float cx,CGFTargetFunc* tfunc,float tol,float* xmin);

//void linmin(p,xi,n,fret,f1dim)
//float (*f1dim)(),*fret,p[],xi[];
//int n;

void linmin(float p[],float xi[],int n,float* fret, CGFTargetFunc* tfunc) {
	//float brent();
	//void mnbrak();

	//int j;
	float xx,xmin,fx,fb,fa,bx,ax;

	ax=0.0;
	xx=1.0;
	//mnbrak(&ax,&xx,&bx,&fa,&fx,&fb,f1dim);
	mnbrak(&ax,&xx,&bx,&fa,&fx,&fb,tfunc);
	//*fret=brent(ax,xx,bx,f1dim,TOL,&xmin);
	*fret=brent(ax,xx,bx,tfunc,TOL,&xmin);
	for (int j=1;j<=n;j++) {
		xi[j] *= xmin;
		p[j] += xi[j];
	}
}
#undef TOL
/* (C) Copr. 1986-92 Numerical Recipes Software 6=Mn.Y". */
