#ifndef __OHL_H_INCLUDED__
#define __OHL_H_INCLUDED__

#define OPERATION_MODE_BATCH 0
#define OPERATION_MODE_ONLINE 1

class DataDesc;

int ohl(double*** r_C, int epochs, int num_components, double noise_level0, double noise_levelf,
	    double alpha0, double lambda0, double alphaf, double lambdaf, 
	    DataDesc* data, int codebook_size, int* schedule, int n_desired,
	    double** init_C, int t_start, int t_max, int operation_mode, int batch_size, 
	    int perform_orthogonal_update, int use_dc_component, int nonnegative); 

int bop(double**** r_P, double**** r_R, 
	  double** C, int num_components, double noise_level, DataDesc* data, int codebook_size, int* schedule, int n_desired, int use_dc_component, int nonnegative, int output=0);

#endif
